/*
      +----------------------------------------------+
      |   /\  /  /\    /\ /\   /\    /\      /\  /\  |
      |  /\ \/  /\ \  / //_/  /\ \  / /     /\ \/\ \ |
      | /  \/  /--\/  \/     /--\/  \/_/\  /  \/  \/ |
      +----------------------------------------------+

Here's some code I decided to release because I really couldn't
get it up to my standards. :-)  I'm hoping however, that some
people may find it a useful example.  Note: it is based on some
code Danzig gave me which obviously came from a S0ny demo prog.

If you haven't figured it out by now, it talks.  (tries to anyway)
After a while, you may begin to understand it. HA ha!  Read
the source or play with the pad to figure out how it works.

I only ask that, you not release new versions with only the
message changed!!  THAT IS LAME!  If you can make the speech
sound clearer, please send me a copy.  I'd love to hear it!

Take care!

-JackRipper <jackripper@napalm.intelinet.com>

P.S. Don't forget to check out our web page: http://napalm.intelinet.com/

*/

#include <sys/types.h>
#include <libetc.h>
#include <libspu.h>
#include <libsnd.h>
#include "phoneme.h"

int Pad(void);
void Init(void);

extern VabHdr *phonz[];

int pitch=0x280;
int ph=0;
int pw;

u_long sample[39];

/* Combine these phonemes to create your own wacky sayings. :-)
   AA,AE,AH,AO,AW,AY,B,CH,D,DH,EH,ER,EY,F,G,HH,IH,IY,JH,K,L,M,N,NG,
   OW,OY,P,R,S,SH,T,TH,UH,UW,V,W,Y,Z,ZH
*/

char word[]=
{
    JH,AE,K,SHH,             // Jack
    TH,AH,SHH,               // the
    R,IH,P, ER,SHH,          // Ripper
    AA,V, SHH,               // of
    N,EY,P,AA,L,M,SHH,       // Napalm
    /* P, R,AW,D,L, IY,SHH,  Proudly? NOT! Kinda embarassing, actually! */
    P,R,IY,Z,EH,N,T,S,SHH,   // presents
    TH,IH,S,SHH,             // this
    T,AA,K,IH,NG,SHH,        // talking
    D,EH,M,OW,SHH,           // demo

    SHH,SHH,
    SHH,SHH,
    SHH,SHH,

    G,R,IY,T,Z,SHH,           // Greetz
    F,L,AY,SHH,               // fly
    T,UW,SHH,                 // to
    D,AE,N,Z,IH,G,SHH,        // Danzig
    N,IH,K,SHH,               // Nik
    AE,N,D,SHH,               // and
    K,EH,M,IH,K,AH,L,SHH,     // Chemical
    SHH,SHH,
    L,EY,T,ER,Z,SHH,SHH,SHH,  // Laterz
    END
};


#define NSPUMALLOCS 64
char spuheap[SPU_MALLOC_RECSIZ * (NSPUMALLOCS + 1)];

main (void)
{
    Init();

    do
    {
	VSync (0);
    }
    while (!Pad());

    SpuSetKey(SpuOff, SPU_ALLCH);
    SpuQuit();
    PadStop();
}


void Init(void)
{
    int i;
    u_long addr;
    u_long size;
    VabHdr *vag;
    SpuVoiceAttr s_attr;
    SpuCommonAttr c_attr;


  printf("      +----------------------------------------------+\n");
  printf("      |   /\\  /  /\\    /\\ /\\   /\\    /\\      /\\  /\\  |\n");
  printf("      |  /\\ \\/  /\\ \\  / //_/  /\\ \\  / /     /\\ \\/\\ \\ |\n");
  printf("      | /  \\/  /--\\/  \\/     /--\\/  \\/_/\\  /  \\/  \\/ |\n");
  printf("      +----------------------------------------------+\n");
printf("\nPlease read the source to see how this works!\n -JackRipper 5-6-98\n");


    ResetGraph(0);		// Initialize Graphics system

    SpuInit();			// Initialize SPU
    SpuInitMalloc(NSPUMALLOCS, spuheap); // Init SPU heap

    PadInit(0);			// Initialize Control pad

    c_attr.mask = (SPU_COMMON_MVOLL | SPU_COMMON_MVOLR);
    c_attr.mvol.left  = 0x3fff; // Master volume (left)
    c_attr.mvol.right = 0x3fff; // Master volume (right)
    SpuSetCommonAttr(&c_attr);

    SpuSetTransferMode(SpuTransByDMA);// select transfer method -> DMA!

    // Calculate the size of all samples
    for (size=0,i=0;vag=phonz[i];i++)
    {
	u_long fsize;

	// Whose dumbass idea was it to store the fsize bigendian?
	fsize=vag->fsize;
	// Be careful here, I am truncating fsize at 16 bits
	fsize=((fsize>>24)&0xff)|((fsize>>8)&0xff00);
	size+=fsize;
	vag->fsize=fsize; // Fix it
    }

    addr=SpuMalloc(size);  // Allocate SPU memory

    SpuSetTransferStartAddr(addr);

    printf("\nTransferring samples...\n");
    for (i=0;vag=phonz[i];i++)
    {
	SpuWritePartly((char *)vag+0x50, vag->fsize-0x30);

	sample[i]=addr;
	SpuIsTransferCompleted(SPU_TRANSFER_WAIT); // Wait for transfer
	addr+=vag->fsize-0x30;
    }

    printf("Done Xferring!\n");

    // items of voice attribute
    s_attr.mask = (SPU_VOICE_VOLL |
		   SPU_VOICE_VOLR |
		   SPU_VOICE_PITCH |
		   SPU_VOICE_WDSA |
		   SPU_VOICE_ADSR_AMODE |
		   SPU_VOICE_ADSR_SMODE |
		   SPU_VOICE_ADSR_RMODE |
		   SPU_VOICE_ADSR_AR |
		   SPU_VOICE_ADSR_DR |
		   SPU_VOICE_ADSR_SR |
		   SPU_VOICE_ADSR_RR |
		   SPU_VOICE_ADSR_SL
		   );

    // set the attributes with all voice
    s_attr.voice = SPU_ALLCH;

    // value of each voice attribute
    s_attr.volume.left = 0x3fff;		// Left volume
    s_attr.volume.right = 0x3fff;		// Right volume
    s_attr.pitch = pitch;			// Pitch
    s_attr.addr = NULL;			// Waveform data start address
    s_attr.a_mode	= SPU_VOICE_LINEARIncN; // Attack curve
    s_attr.s_mode	= SPU_VOICE_LINEARIncN; // Sustain curve
    s_attr.r_mode	= SPU_VOICE_LINEARDecN; // Release curve
    s_attr.ar = 0x0;				// Attack rate value
    s_attr.dr = 0x0;				// Decay rate value 
    s_attr.sr = 0x0;				// Sustain rate value
    s_attr.rr = 0x0;				// Release rate value
    s_attr.sl = 0xf;				// Sustain level value

    SpuSetVoiceAttr(&s_attr);
}


void PlayPhoneme(u_long addr)
{
    SpuVoiceAttr s_attr;

    s_attr.mask = SPU_VOICE_PITCH | SPU_VOICE_WDSA;
    s_attr.addr = addr;
    s_attr.voice = SPU_VOICECH(0);
    s_attr.pitch = pitch;
    SpuSetKeyOnWithAttr(&s_attr);
}

void Speak(void)
{
    static int sleep=0;
    int ph;

    if (sleep)
    {
	sleep--;
	return;
    }

    ph=word[pw]; // Get the next phoneme

    if (ph==SHH) // Pause?
    {
	sleep=12;
	printf("[SHH]\n");
    }
    else
    {
	PlayPhoneme(sample[ph]);
	printf("[%s] ", (char *)phonz[ph]+sizeof(VabHdr));
    }

    if (word[++pw]==END) // Nothing more to say so say it again!
	pw=0;
}


int Pad(void)
{
    static u_long op=0;// old pad value (from last call)
    u_long np, pad;

    op&=~(PADRleft|PADLup|PADLdown);	// these repeat
    pad=PadRead(0);
    np=pad&~op;	// Mask out already pressed buttons
    op=pad;	// Save button state for next time

    if (np & PADselect) // Good night
	return(1);

    if (np & PADRdown) // Play current phoneme
    {
	if (SpuGetKeyStatus(SPU_0CH)!=1) // Wait for previous sample to finish
	    PlayPhoneme(sample[ph]);
	PrintPhoneme(ph);
    }

    if (np & PADRleft) // Speak words
	if (SpuGetKeyStatus(SPU_0CH)!=1)
	    Speak();

    if (np & PADLdown)
    {
	pitch--;
	printf("Pitch: %d\n", pitch);
    }

    if (np & PADLup)
    {
	pitch++;
	printf("Pitch: %d\n", pitch);
    }

    if (np & PADstart)
    {
	pw=0;
	ph=0;
	printf("\nRESET!\n");
    }

    if (np & PADL1 && pw) // Backspace :-)
    {
	pw--;
	if (word[pw]==SHH)
	    printf("\n[SHH]\n");
	else
	    printf("\nIndex: %2d Name: %2s SPU Address: %X\n", word[pw],
		   (char *)phonz[word[pw]]+sizeof(VabHdr), sample[word[pw]]);
    }

    if (np & PADRup && ph) // Previous sound
    {
	ph--;
	PrintPhoneme(ph);
    }

    if (np & PADRright) // Next sound
    {
	if (!phonz[++ph])
	    ph=0;
	PrintPhoneme(ph);
    }

    return(0);
}


PrintPhoneme(int ph)
{
    printf("\nIndex: %2d Name: %2s SPU Address: %X\n", ph, 
	   (char *)phonz[ph]+sizeof(VabHdr), sample[ph]);
}
